#ifndef _CONSTANTS_H_

#include <string>
#include <sstream>
#include <vector>
#include <algorithm>

#include "IwDebug.h"
#include "Iw2DSceneGraph.h"
#include "IwGx.h"
#include "s3eFile.h"

#define _CONSTANTS_H_

#define TILE_WIDTH 32
#define TILE_HEIGHT 32
#define HALF_TILE_WIDTH 16
#define HALF_TILE_HEIGHT 16

#define EMPTY_TILE_NR -1

#define MAP_LINE_INPUT_MAXLEN 1024
#define MAX_TEXT_LEN 256

//#define PAN_SPEED 8.0f

#define TEXT_SHADOW_OFFSET_X 2.0f
#define TEXT_SHADOW_OFFSET_Y 2.0f

// ---
#define TILENR_PLAYER_SPAWN 1
#define TILENR_EXIT_SIGN_A 2
#define TILENR_EXIT_SIGN_B 3
#define TILENR_NEST_SPAWN 4

#define TILENR_NEST_FULL_A 128
#define TILENR_NEST_FULL_B 129

#define MIN_BLOCKED_TILENR 80
#define MAX_BLOCKED_TILENR 127

// -- 
#define FRAME_RATE_HZ 60
#define HALF_FRAME_RATE_HZ 30
#define QUARTER_FRAME_RATE_HZ 15

// ---
#define BASIC_NEST_SPAWN_PER_LEVEL 3
#define BASIC_SPAWN_RATE_SECONDS 30 
#define BASIC_EXPANSION_RATE_SECONDS 15 

// ---
enum PlayerHeading {
	PLAYER_HEADING_SOUTH = 0,
	PLAYER_HEADING_SOUTH_WEST = 1,
	PLAYER_HEADING_WEST = 2,
	PLAYER_HEADING_NORTH_WEST = 3,
	PLAYER_HEADING_NORTH = 4,
	PLAYER_HEADING_NORTH_EAST = 5,
	PLAYER_HEADING_EAST = 6,
	PLAYER_HEADING_SOUTH_EAST = 7
};

#define PLAYER_MAX_MOVEMENT_SPEED 4.0f
#define PLAYER_ACCELERATION 1.0f
#define PLAYER_DECELERATION 1.5f
#define PLAYER_COLLISION_RADIUS 14

#define PROJECTILE_SPEED 8.0f
#define PROJECTILE_LIFETIME 300
#define PROJECTILE_SHOT_INTERVAL 30

#endif
