/*
 * (C) 2001-2012 Marmalade. All Rights Reserved.
 *
 * This document is protected by copyright, and contains information
 * proprietary to Marmalade.
 *
 * This file consists of source code released by Marmalade under
 * the terms of the accompanying End User License Agreement (EULA).
 * Please do not use this program/source code before you have read the
 * EULA and have agreed to be bound by its terms.
 */
#include "s3e.h"
#include "IwDebug.h"
#include "Iw2DSceneGraph.h"
#include "IwGx.h"
#include "IwRandom.h"

#include "Application.h"

using namespace Iw2DSceneGraphCore;
using namespace Iw2DSceneGraph;

CIwColour clearColour;
CIwColour blackColour;
CIwColour whiteColour;
CIwColour blueColour;
CIwColour redColour;
CIwColour yellowColour;
CIwColour greenColour;

Application* g_App = NULL;
bool g_QuitGame = false;

int main()
{
    Iw2DInit();
	IwResManagerInit();

	clearColour.Set(0x22, 0x22, 0x22, 0xff);
	blackColour.Set(0x00, 0x00, 0x00, 0xff);
	whiteColour.Set(0xff, 0xff, 0xff, 0xff);
	blueColour.Set(0x55, 0x7f, 0x9e, 0xff);
	redColour.Set(0x7a, 0x43, 0x4a, 0xff);
	yellowColour.Set(0xa9, 0xa2, 0x76, 0xff);
	greenColour.Set(0x75, 0x86, 0x49, 0xff);

	float frameStep = 1000.0f / 20.0f;

	IwRandSeed((int32)s3eTimerGetMs());

	g_App = new Application();
	g_App->Init();

    while (!s3eDeviceCheckQuitRequest() && !g_QuitGame)
    {
        s3eKeyboardUpdate();
        s3ePointerUpdate();

		g_App->Update();

		g_App->Render();

		Iw2DSurfaceShow();
        s3eDeviceYield(0);
    }

	g_App->Shutdown();
	delete g_App;

	IwResManagerTerminate();
    Iw2DTerminate();

    return 0;
}
