#ifndef _LEVEL_H_
#define _LEVEL_H_

#include "Constants.h"

#include "Projectile.h"

class Level
{
public:
	Level();
	~Level();

	void LoadFromFile(std::string filenameBg, std::string filenameMg, uint32 newWidth, uint32 newHeight);
	void Update();
	void Render();

	int32 ReadBgTileNr(int32 tileX, int32 tileY);
	int32 ReadBgTileNrFromPixels(int32 pixelX, int32 pixelY);
	int32 ReadMgTileNr(int32 tileX, int32 tileY);
	int32 ReadMgTileNrFromPixels(int32 pixelX, int32 pixelY);
	
	CIwVec2 ReadPlayerSpawnCoordinates();

	bool HandleShotHittingNests(Projectile projectile, CIwFVec2& nestPosition);
	uint32 CountNests();

public:
	bool ExitActive;

private:
	CIwArray<std::string> &split(const std::string &s, char delim, CIwArray<std::string> &elems);
	CIwArray<std::string> split(const std::string &s, char delim);

	void SpawnStartingNests();

	void RenderTiles();
	void RenderSpawnedNests();

private:
	bool validLevelLoaded;

	CIwArray<int32> tilesBg;
	CIwArray<int32> tilesMg;
	uint32 nosTilesWidth;
	uint32 nosTilesHeight;

	CIwVec2 playerSpawnTileCoords;

	uint blinkIndex;
	uint wiggleIndex;

	CIwArray<CIwVec2> allSpawnNestsTileCoordinates;
	CIwArray<CIwVec2> spawnedNestsTileCoordinates;
};

#endif