#include "Player.h"
#include "Application.h"

extern Application* g_App;

Player::Player()
{
	Heading = PLAYER_HEADING_SOUTH_WEST;
	IsHit = false;
	Health = 100.0f;
	Score = 0;
	Level = 1;
}

Player::~Player()
{

}

void Player::Update()
{

}

void Player::Render()
{
	int32 origSurfaceWidth = Iw2DGetSurfaceWidth();
	int32 origSurfaceHeight = Iw2DGetSurfaceHeight();

	int32 halfSurfaceWidth = origSurfaceWidth / 2;
	int32 halfSurfaceHeight = origSurfaceHeight / 2;

	float targetX = (float)(halfSurfaceWidth - HALF_TILE_WIDTH);
	float targetY = (float)(halfSurfaceHeight - HALF_TILE_HEIGHT);
	CIwFVec2 target(targetX, targetY);

	CIwFVec2 dimension((float)TILE_WIDTH, (float)TILE_HEIGHT);

	if (target.x > -dimension.x && target.x < origSurfaceWidth && target.y > -dimension.y && target.y < origSurfaceHeight)
	{
		float offset = IsHit == true ? 256.0f : 0.0f;
		float sourceX = offset + (float)(Heading * TILE_WIDTH);
		float sourceY = 448.0f;
		CIwFVec2 source(sourceX, sourceY);

		Iw2DDrawImageRegion(g_App->GetTileImage(), target, source, dimension);
	}
}

void Player::Shutdown()
{
}

